//sqrt(1-(1-i)x) which has a branch point at (1/2 + 1/2 i)

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

const int precision=8;
const int zmaxsize=40;  //0 ought to do
const int cmaxsize=40;
int qqq;

#include "genprec.h"
#include "cgenprec.h"
#include "apps.h"

int n;        //actual size = 10 set in main below

complexmp p,test;
complexmp a[cmaxsizepad];
complexmp b[cmaxsizepad];
complexmp c[cmaxsizepad];
cpademp d;
complexmp dnum[cmaxsizepad];         //done exactly as in padedex.cc
complexmp dden[cmaxsizepad];
complexmp myrootsofnum[cmaxsizepad];
complexmp myrootsofden[cmaxsizepad];



int main()
  {int i;
   zsuppi();
   zsupe();                 //run this if e is needed
   zsuplogsp();             //run this if log base e of 10 is needed
   n=20;

   cout<<'\n';
   cout<<"the example is the 10,10 Pade Approximant to sqrt((1+(2+i)x)/(1+(1+i)x))"<<'\n';
   zmessage="  ";
   zbreak();
   cout<<'\n';

   a[0]=cinttomp(1,0);       //compute series 
   a[1]=cinttomp(2,1);

   for (i=2;i<n+1;i++)       //remaining terms in a are zero
     {a[i]=cinttomp(0,0);}            
   b[0]=cinttomp(1,0);         //b=1+(1+i)x
   b[1]=cinttomp(1,1);
   for (i=2;i<n+1;i++)
     {b[i]=cinttomp(0,0);}
   p=-cinttomp(1,0);         //p=-1
   c<cstonth(n,b,p);           //b^(-1)       //looks ok
   a<csmult(n,a,c);        //a*b^(-1)
   p=cinttomp(1,0);
   p=p/2;
   c<cstonth(n,a,p);            //sqrt(a*b^(-1))  //looks ok
   for (i=0;i<n+1;i++)
     {printmp(c[i]);}
   zmessage="the series for sqrt((1+(2+i)x)/(1+(1+i)x)";
   zbreak();
   d<cpadeapprox(n/2,n/2,c);     //form pade approximant
   dnum<cextractnum(n/2,d);       //seems exactly same as in real?
   dden<cextractden(n/2,d);
   for (i=0;i<n/2+1;i++)
     {cout<<"i= "<<i<<'\n';
      printmp(dnum[i]);}           //hmm
   zmessage="numerator";
   zbreak();
   cout<<'\n';
   for (i=0;i<n/2+1;i++)
     {printmp(dden[i]);}
   zmessage="denominator";
   zbreak();
   cout<<'\n';
   printmp(dnum[n/2]/dden[n/2]);
   test=cinttomp(3,-1)/2;          //hmm
   test=sqrt(test);
   zmessage="value at infinity which should be sqrt((2+i)/(1+i))=";
   zbreak();
   printmp(test);
   zmessage=" ";
   zbreak();

   rotationangle=inttomp(2)/10;
   myrootsofnum<csolvpoly(n/2,dnum,rotationangle);
   for (i=1;i<n/2+1;i++)  
     {printmp(myrootsofnum[i]);}
   zmessage="roots of numerator";
   zbreak();
   cout<<'\n';
   myrootsofden<csolvpoly(n/2,dden,rotationangle);
   for (i=1;i<n/2+1;i++)
     {printmp(myrootsofden[i]);}
   zmessage="roots of denominator";
   zbreak();

   return 0;
  }

